跳转到内容

Overview

  • Version: 2.0.0
  • Servers: https://store.xsolla.com/api
  • Contact Us by Email
  • Contact URL: https://xsolla.com/
  • Required TLS version: 1.2

LiveOps is a toolkit for driving ongoing player engagement through promotions and personalized offers.

Use the API to manage the following features:

  • Promotions — create and manage coupons, promo codes, discounts, and bonus campaigns.
  • Personalization — specify the conditions for displaying the item catalog and applying promotions only for certain authorized users.
  • Promotion limits — set a limit on how many times a promotion can be used by a user and configure scheduled resets for these limits.
  • Reward chains & Value points — configure reward progressions tied to value point accumulation.
  • Daily chains — set up recurring daily rewards to motivate regular logins.
  • Offer chains — build sequential purchase offers with per-step pricing and free reward options.
  • Upsell — a sales method in which the user is offered to buy an item with additional value.

API calls

The API is divided into the following groups:

  • Admin — calls for creating, updating, activating, and deleting campaigns and chain configurations. Authenticated via basic access authentication with your merchant or project credentials.
  • Client — calls for retrieving available promotions, getting active chains, redeeming codes, and claiming rewards on behalf of authenticated end users. Authenticated via user JWT.

Authentication

API calls require authentication either on behalf of a user or on behalf of a project. The authentication scheme used is specified in the Security section in the description of each call.

Authentication using user's JWT

User's JWT authentication is used when a request is sent from a browser, mobile application, or game. By default, the XsollaLoginUserJWT scheme is applied. For details on how to create a token, see the Xsolla Login API documentation.

The token is passed in the Authorization header in the following format: Authorization: Bearer <user_JWT>, where <user_JWT> is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:

eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aI

Alternatively, you can use a token for opening the payment UI.

Basic HTTP authentication

Basic HTTP authentication is used for server-to-server interactions, when an API call is sent directly from your server rather than from a user's browser or mobile application. HTTP Basic authentication with an API key is typically used.

Note

The API key is confidential and must not be stored or used in client applications.

With basic server-side authentication, all API requests must include the following header:

  • for basicAuthAuthorization: Basic <your_authorization_basic_key>, where your_authorization_basic_key is the project_id:api_key pair encoded in Base64
  • for basicMerchantAuthAuthorization: Basic <your_authorization_basic_key>, where your_authorization_basic_key is the merchant_id:api_key pair encoded in Base64

You can find the parameter values in Publisher Account:

  • merchant_id is displayed:
    • In Company settings > Company.
    • In the URL in the browser address bar on any Publisher Account page. The URL has the following format: https://publisher.xsolla.com/<merchant_id>.
  • project_id is displayed:
    • Next to the project name in Publisher Account.
    • In the URL in the browser address bar when working on a project in Publisher Account. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.
  • api_key is shown in Publisher Account only at the time of creation and must be stored securely on your side. You can create an API key in the following sections:
Notice

If a required API call doesn't include the project_id path parameter, use an API key that is valid across all company projects for authorization.

For more information about working with API keys, see the API references.

Authentication with guest access support

The AuthForCart authentication scheme is used for cart purchases and supports two modes:

  1. Authentication with a user's JWT. The token is passed in the Authorization header in the following format: Authorization: Bearer <user_JWT>, where <user_JWT> is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:
eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aI

Alternatively, you can use a token for opening the payment UI.

  1. Simplified mode without Authorization header. This mode is used only for unauthorized users and can be applied only for game key sales. Instead of a token, the request must include the following headers:
    • x-unauthorized-id with a request ID
    • x-user with the user's email address encoded in Base64

Core entity structure

Items of all types (virtual items, bundles, virtual currency, and keys) use a similar data structure. Understanding the basic structure simplifies working with the API and helps you navigate the documentation more easily.

Note

Some calls may include additional fields but they don't change the basic structure.

Identification

  • merchant_id — company ID in Publisher Account
  • project_id — project ID in Publisher Account
  • sku — item SKU, unique within the project

Store display

  • name — item name
  • description — item description
  • image_url — image URL
  • is_enabled — item availability
  • is_show_in_store — whether the item is displayed in the catalog

For more information about managing item availability in the catalog, see the documentation.

Organization

  • type — item type, for example, a virtual item (virtual_item) or bundle (bundle)
  • groups — groups the item belongs to
  • order — display order in the catalog

Sale conditions

  • prices — prices in real or virtual currency
  • limits — purchase limits
  • periods — availability periods
  • regions — regional restrictions

Example of core entity structure:

{
  "attributes": [],
  "bundle_type": "virtual_currency_package",
  "content": [
    {
      "description": {
        "en": "Main in-game currency"
      },
      "image_url": "https://.../image.png",
      "name": {
        "en": "Crystals",
        "de": "Kristalle"
      },
      "quantity": 500,
      "sku": "com.xsolla.crystal_2",
      "type": "virtual_currency"
    }
  ],
  "description": {
    "en": "Crystals x500"
  },
  "groups": [],
  "image_url": "https://.../image.png",
  "is_enabled": true,
  "is_free": false,
  "is_show_in_store": true,
  "limits": {
    "per_item": null,
    "per_user": null,
    "recurrent_schedule": null
  },
  "long_description": null,
  "media_list": [],
  "name": {
    "en": "Medium crystal pack"
  },
  "order": 1,
  "periods": [
    {
      "date_from": null,
      "date_until": "2020-08-11T20:00:00+03:00"
    }
  ],
  "prices": [
    {
      "amount": 20,
      "country_iso": "US",
      "currency": "USD",
      "is_default": true,
      "is_enabled": true
    }
  ],
  "regions": [],
  "sku": "com.xsolla.crystal_pack_2",
  "type": "bundle",
  "vc_prices": []
}

Basic purchase flow

The Xsolla API allows you to implement in-game store logic, including retrieving the item catalog, managing the cart, creating orders, and tracking their status. Depending on the integration scenario, API calls are divided into Admin and Catalog subsections, which use different authentication schemes.

The following example shows a basic flow for setting up and operating a store, from item creation to purchase.

Create items and groups (Admin)

Create an item catalog for your store, such as virtual items, bundles, or virtual currency.

Example API calls:

Set up promotions, chains, and limits (Admin)

Configure user acquisition and monetization tools, such as discounts, bonuses, daily rewards, or offer chains.

Example API calls:

Get item information (Client)

Configure item display in your application.

Notice

Do not use API calls from the Admin subsection to build a user catalog. These API calls have rate limits and aren't intended for user traffic.

Example API calls:

Note

By default, catalog API calls return items that are currently available in the store at the time of the request. To retrieve items that are not yet available or are no longer available, include the parameter "show_inactive_time_limited_items": 1 in the catalog request.

Sell items

You can sell items using the following methods:

  • Fast purchase — sell one SKU multiple times.
  • Cart purchase — the user adds items to the cart, removes items, and updates quantities within a single order.

If an item is purchased using virtual currency instead of real money, use the Create order with specified item purchased by virtual currency API call. The payment UI is not required, as the charge is processed when the API call is executed.

For free item purchase, use the Create order with specified free item API call or the Create order with free cart API call. The payment UI is not required — the order is immediately set to the done status.

Fast purchase

Use the client-side API call to create an order with a specified item. The call returns a token used to open the payment UI.

Note

Discount information is available to the user only in the payment UI. Promo codes are not supported.

Cart purchase

Cart setup and purchase can be performed on the client or on the server side.

Set up and purchase a cart on the client

Implement the logic of adding and removing items by yourself. Before calling the API for setting up a cart, you will not have information about which promotions will be applied to the purchase. This means that the total cost and details of the added bonus items will not be known.

Implement the following cart logic:

  1. After the player has filled a cart, use the Fill cart with items API call. The call returns the current information about the selected items (prices before and after discounts, bonus items).
  2. Update the cart contents based on user actions:
Note

To get the current status of the cart, use the Get current user's cart API call.
  1. Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to new status by default.

Set up and purchase a cart on the server

This setup option may take longer for setting the cart up, since each change to the cart must be accompanied by API calls.

Implement the following cart logic:

  1. After the player has filled a cart, use the Fill cart with items API call. The call returns current information about the selected items (prices before and after discounts, bonus items).
  2. Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to new status by default.

Open payment UI

Use the returned token to open the payment UI in a new window. Other ways to open the payment UI are described in the documentation.

ActionEndpoint
Open in production environment.https://secure.xsolla.com/paystation4/?token={token}
Open in sandbox mode.https://sandbox-secure.xsolla.com/paystation4/?token={token}
Note

Use sandbox mode during development and testing. Test purchases don't charge real accounts. You can use test bank cards.

After the first real payment is made, a strict sandbox payment policy takes effect. A payment in sandbox mode is available only to users specified in Publisher Account > Company settings > Users.

Buying virtual currency and items for real currency is possible only after signing a license agreement with Xsolla. To do this, in Publisher Account, go to Agreements & Taxes > Agreements, complete the agreement form, and wait for confirmation. It may take up to 3 business days to review the agreement.

To enable or disable sandbox mode, change the value of the sandbox parameter in the request for fast purchase and cart purchase. Sandbox mode is off by default.

Possible order statuses:

  • new — order created
  • paid — payment received
  • done — item delivered
  • canceled — order canceled
  • expired — payment expired

Track order status using one of the following methods:

Pagination

API calls that return large sets of records (for example, when building a catalog) return data in pages. Pagination is a mechanism that limits the number of items returned in a single API response and allows you to retrieve subsequent pages sequentially.

Use the following parameters to control the number of returned items:

  • limit — number of items per page
  • offset — index of the first item on the page (numbering starts from 0)
  • has_more — indicates whether another page is available
  • total_items_count — total number of items

Example request:

GET /items?limit=20&offset=40

Response example:

{
  "items": [...],
  "has_more": true,
  "total_items_count": 135
}

It is recommended to send subsequent requests until the response returns has_more = false.

Date and time format

Dates and time values are passed in the ISO 8601 format.

The following are supported:

  • UTC offset
  • null value when there is no time restriction for displaying an item
  • Unix timestamp (in seconds) used in some fields

Format: YYYY-MM-DDTHH:MM:SS±HH:MM

Example: 2026-03-16T10:00:00+03:00

Localization

Xsolla supports localization of user-facing fields such as item name and description. Localized values are passed as an object where the language code is used as the key. The full list of supported languages is available in the documentation.

Supported fields

Localization can be specified for the following parameters:

  • name
  • description
  • long_description

Locale format

The locale key can be specified in one of the following formats:

  • Two-letter language code: en, ru
  • Five-letter language code: en-US, ru-RU, de-DE

Examples

Example with a two-letter language code:

{
  "name": {
    "en": "Starter Pack",
    "ru": "Стартовый набор"
  }
}

Example with a five-letter language code:

{
  "description": {
    "en-US": "Premium bundle",
    "de-DE": "Premium-Paket"
  }
}

Error response format

If an error occurs, the API returns an HTTP status and a JSON response body. The full list of store-related errors is available in the documentation.

Response example:

{
  "errorCode": 1102,
  "errorMessage": "Validation error",
  "statusCode": 422,
  "transactionId": "c9e1a..."
}
  • errorCode — error code.
  • errorMessage — short error description.
  • statusCode — HTTP response status.
  • transactionId — request ID. Returned only in some cases.
  • errorMessageExtended — additional error details, such as request parameters. Returned only in some cases.

Extended response example:

{
  "errorCode": 7001,
  "errorMessage": "Chain not found",
  "errorMessageExtended": {
    "chain_id": "test_chain_id",
    "project_id": "test_project_id",
    "step_number": 2
  },
  "statusCode": 404
}

Common HTTP status codes

  • 400 — invalid request
  • 401 — authentication error
  • 403 — insufficient permissions
  • 404 — resource not found
  • 422 — validation error
  • 429 — rate limit exceeded

Recommendations

  • Handle the HTTP status and the response body together.
  • Use errorCode to process errors related to application logic.
  • Use transactionId to identify requests more quickly when analyzing errors.
下载 OpenAPI 描述
语言
服务器
https://store.xsolla.com/api/
Mock server
https://xsolla.redocly.app/_mock/zh/api/liveops/

Overview

Promotions are marketing tools designed to attract new users and increase sales. Using Xsolla API, you can configure the following promotions:

  • Discounts — reduced prices on selected items.
  • Bonuses — items granted to users along with their purchase.
  • Coupons — codes that allow users to receive one or more bonus items when redeeming.
  • Promo codes — codes that allow users to receive bonus items, a discount on a specific item, or a discount on the entire cart. Unlike coupons that are redeemed after the user enters them, promo codes are redeemed during a purchase (at checkout).
  • Unique offers — hidden items displayed in the catalog to users who have entered a unique offer code. If the code is not entered, the items are not displayed.

Example flow for configuring a discount promotion:

  1. Create items using the calls from the Admin subsection of the Virtual items and currency, Bundles, or Game keys groups.
  2. Create a promotion using the Create discount promotion for item call. In the items array, pass the necessary item SKUs.
  3. Set up promotion validity periods. To do this, call the Create discount promotion for item or Update item promotion methods, and pass the promotion_periods field as an array of objects where date_from defines the start, and date_until defines the end date of the validity period.
  4. Activate a promotion using the Update item promotion call. Pass the "is_enabled": true parameter.
  5. To get information about item prices, including discounted prices, call the client API methods for getting an item catalog from the Common > Catalog, Virtual Items and Currency > Catalog, and Bundles > Catalog subsections.

Promotion configuration example

Refer to our documentation for detailed information about configuring promotions:

Common API calls

You can call API methods from this subsection to manage different types of promotions.

操作

优惠券

Call API methods from this subsection to configure and manage coupon promotions.

Note

Refer to our documentation for detailed information about coupons.

操作

促销码

Call API methods from this subsection to configure and manage promo code promotions.

Note

Refer to our documentation for detailed information about promo codes.

操作

特别目录优惠

Call API methods from this subsection to configure and manage unique catalog offers.

Note

Refer to our documentation for detailed information about unique offers.

操作

折扣

Call API methods from this subsection to configure and manage discount promotions.

Note

Refer to our documentation for detailed information about discounts.

操作

奖励

Call API methods from this subsection to configure and manage bonus promotions.

Note

Refer to our documentation for detailed information about bonuses.

操作

获取奖励促销活动Server-sideAdmin

请求

获取奖励促销活动。

促销活动对进行购买的用户给予免费的奖励商品。 促销活动可以应用于项目中的任何购买或包含特定商品的购买。

安全
basicAuth
路径
project_idinteger必需

Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.

示例: 44056
promotion_idinteger必需

促销活动ID。项目内的唯一促销活动标识符。

示例: 111425
curl -i -X GET \
  -u <username>:<password> \
  https://store.xsolla.com/api/v3/project/44056/admin/promotion/111425/bonus

响应

奖励促销活动已成功收到。

正文application/json
attribute_conditionsArray of type = string (object) or type = number (object) or type = date (object)(promotion_user-attribute_conditions_model-get)[ 1 .. 100 ] items

用户属性验证条件。 根据用户属性是否满足所有指定条件来确定促销活动可用性。

One of:
attribute_conditions[].​attributestring(user-attribute_conditions_properties_attribute)[ 1 .. 255 ] characters^[-_.\d\w]+$

用户属性代码。

attribute_conditions[].​can_be_missingboolean(user-attribute_conditions_properties_can_be_missing)

表示即使用户属性中缺少属性仍满足条件。传递true可向不具有此属性的用户显示该项目。具有该属性但值与条件中指定的值不匹配的用户将看不到该商品。传递false则具有该属性但值与条件中指定的值不匹配或缺少该属性的用户将看不到该商品。

attribute_conditions[].​operatorstring(user-attribute_conditions_properties_operator_string)

Type of operation performed by condition. For string attribute type.

Possible values:

  • eq — Equals
  • ne — Not equals
枚举"eq""ne"
attribute_conditions[].​typestring(user-attribute_conditions_properties_type-string)

用户属性类型。

"string"
attribute_conditions[].​valuestring(user-attribute_conditions_properties_value)<= 255 characters

与用户属性值进行比较的条件值。类型取决于属性类型。

bonusArray of objects or null
bonus[].​quantitynumber

商品数量。

默认值 1
bonus[].​skustring

商品SKU。

默认值 "elven_shield"
conditionArray of objects or null

要应用促销必须在购买项中包含的一组商品。如果此参数为null,则促销将应用于项目内的任何购买。

condition[].​skustring

商品SKU。

默认值 "elven_sword"
excluded_promotionsArray of integers(excluded_promotions)

应用此促销活动时要排除的促销活动ID列表。
Example:[12, 789]

idinteger

促销活动ID。项目内的唯一促销活动标识符。

is_enabledboolean
默认值 true
limitsobject(Promotions_promotion_limits_response)

促销活动限制。

limits.​per_iteminteger or null

全局商品限制。

示例: 10
limits.​per_userobject or null

针对单独用户的促销活动限制。

limits.​per_user.​totalinteger

用户可以购买的商品总数。您可以在发布商帐户中设置此数字或使用商店实体的管理端点(限制对象)。

示例: 5
limits.​recurrent_scheduleobject or null(promotion_recurrent_schedule_response)

限制次数刷新周期。

limits.​recurrent_schedule.​per_userinterval_type = daily (object) or interval_type = weekly (object) or interval_type = monthly (object)

用户限制刷新周期。

One of:

每天类型的用户限制次数刷新。

limits.​recurrent_schedule.​per_user.​displayable_reset_next_datestring(date-time)

应重置限制次数的日期和时间 (ISO 8601)。

示例: "2023-02-28T11:00:00+08:00"
limits.​recurrent_schedule.​per_user.​displayable_reset_start_datestring(date-time)

第一次限制次数刷新的日期和时间 (ISO 8601)。

示例: "2023-02-28T11:00:00+08:00"
limits.​recurrent_schedule.​per_user.​interval_typestring

循环刷新周期类型。

"daily"
limits.​recurrent_schedule.​per_user.​reset_next_dateinteger

限制次数刷新的日期和时间(Unix时间戳)。

示例: 1677553200
limits.​recurrent_schedule.​per_user.​timestring(full-time)

所需时区的限制次数刷新时间(四舍五入到小时)。

示例: "11:00:00+03:00"
nameobject

促销活动名称。应包含键/值对, 其中键是"^[a-z]{2}-[A-Z]{2}$"格式的区域设置,值是字符串。

示例: {"de-DE":"Sommersaison Bonus","en-US":"Summer season bonus"}
name.​property name*string附加属性
price_conditionsArray of objects or null(price_conditions_bonus)

包含条件的对象数组,用于设置应用促销活动的价格范围。
促销活动仅应用于价格符合数组中所有条件的商品。如果传递此数组,请将condition对象的值设置为null

price_conditions[].​operatorstring必需

Comparison operator for setting the price range for applying the promotion.

Possible values:

  • ge — Greater or equal
  • gt — Greater than
  • le — Less or equal
  • lt — Less than
  • eq — Equals
  • ne — Not equals
枚举"ge""gt""le""lt""eq""ne"
price_conditions[].​valuestring^\d+(\.\d{1,4})?$必需

用于决定应用促销活动的价格范围的值。

promotion_periodsArray of objects(promotion_periods)

促销活动有效期。若指定了多个时间段,则date_fromdate_until均为必需。

promotion_periods[].​date_fromstring(date-time)必需

指定促销活动的开始日期。

示例: "2020-08-11T10:00:00+03:00"
promotion_periods[].​date_untilstring or null(date-time)

促销活动的结束日期。设置为null时,促销活动永久有效。仅在指定单个有效期时可设置为null

示例: "2020-08-11T20:00:00+03:00"
响应
application/json
{ "bonus": [ {}, {}, {} ], "condition": [ {}, {} ], "excluded_promotions": [ 23, 45 ], "id": 1, "is_enabled": true, "limits": { "per_item": null, "per_user": {}, "recurrent_schedule": {} }, "name": { "de-DE": "Neujahrsbonus", "en-US": "New Year Bonus" }, "price_conditions": [ {}, {} ], "promotion_periods": [ {} ] }

更新奖励促销活动Server-sideAdmin

请求

更新促销活动。

注意

如果只想更新促销活动的一部分,也应在请求中传输所有必需数据。

促销活动对进行购买的用户给予免费的奖励商品。 促销活动可以应用于项目中的任何购买或包含特定商品的购买。

安全
basicAuth
路径
project_idinteger必需

Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.

示例: 44056
promotion_idinteger必需

促销活动ID。项目内的唯一促销活动标识符。

示例: 111425
正文application/json
attribute_conditionsArray of type = string (object) or type = number (object) or type = date (object)(promotion_user-attribute_conditions_model-post)[ 1 .. 100 ] items

用户属性验证条件。 根据用户属性是否满足所有指定条件来确定促销活动可用性。

One of:
attribute_conditions[].​attributestring(user-attribute_conditions_properties_attribute)[ 1 .. 255 ] characters^[-_.\d\w]+$必需

用户属性代码。

attribute_conditions[].​can_be_missingboolean(user-attribute_conditions_properties_can_be_missing)

表示即使用户属性中缺少属性仍满足条件。传递true可向不具有此属性的用户显示该项目。具有该属性但值与条件中指定的值不匹配的用户将看不到该商品。传递false则具有该属性但值与条件中指定的值不匹配或缺少该属性的用户将看不到该商品。

attribute_conditions[].​operatorstring(user-attribute_conditions_properties_operator_string)必需

Type of operation performed by condition. For string attribute type.

Possible values:

  • eq — Equals
  • ne — Not equals
枚举"eq""ne"
attribute_conditions[].​typestring(user-attribute_conditions_properties_type-string)必需

用户属性类型。

"string"
attribute_conditions[].​valuestring(user-attribute_conditions_properties_value)<= 255 characters必需

与用户属性值进行比较的条件值。类型取决于属性类型。

bonusArray of objects or null必需
bonus[].​quantitynumber

商品数量。

默认值 1
bonus[].​skustring

商品SKU。

默认值 "elven_shield"
conditionArray of objects or null必需

要应用促销必须在购买项中包含的一组商品。如果此参数为null,则促销将应用于项目内的任何购买。

condition[].​skustring

商品SKU。

默认值 "elven_sword"
excluded_promotionsArray of integers(excluded_promotions)

应用此促销活动时要排除的促销活动ID列表。
Example:[12, 789]

idinteger

促销活动ID。项目内的唯一促销活动标识符。

is_enabledboolean(Promotions_is_enabled)

是否启用了促销活动。

limitsobject(Promotions_promotion_limits)

促销活动限制。

limits.​per_userinteger or null

针对单独用户的促销活动限制。

limits.​recurrent_scheduleobject or null(promotion_recurrent_schedule_response)

限制次数刷新周期。

limits.​recurrent_schedule.​per_userinterval_type = daily (object) or interval_type = weekly (object) or interval_type = monthly (object)

用户限制刷新周期。

One of:

每天类型的用户限制次数刷新。

limits.​recurrent_schedule.​per_user.​displayable_reset_next_datestring(date-time)

应重置限制次数的日期和时间 (ISO 8601)。

示例: "2023-02-28T11:00:00+08:00"
limits.​recurrent_schedule.​per_user.​displayable_reset_start_datestring(date-time)

第一次限制次数刷新的日期和时间 (ISO 8601)。

示例: "2023-02-28T11:00:00+08:00"
limits.​recurrent_schedule.​per_user.​interval_typestring

循环刷新周期类型。

"daily"
limits.​recurrent_schedule.​per_user.​reset_next_dateinteger

限制次数刷新的日期和时间(Unix时间戳)。

示例: 1677553200
limits.​recurrent_schedule.​per_user.​timestring(full-time)

所需时区的限制次数刷新时间(四舍五入到小时)。

示例: "11:00:00+03:00"
nameobject必需

促销活动名称。应包含键/值对,其中键是"^[a-z]{2}-[A-Z]{2}$"格式的区域设置,值是字符串。

示例: {"de-DE":"Sommersaison Bonus","en-US":"Summer season bonus"}
name.​property name*string附加属性
price_conditionsArray of objects or null(price_conditions_bonus)

包含条件的对象数组,用于设置应用促销活动的价格范围。
促销活动仅应用于价格符合数组中所有条件的商品。如果传递此数组,请将condition对象的值设置为null

price_conditions[].​operatorstring必需

Comparison operator for setting the price range for applying the promotion.

Possible values:

  • ge — Greater or equal
  • gt — Greater than
  • le — Less or equal
  • lt — Less than
  • eq — Equals
  • ne — Not equals
枚举"ge""gt""le""lt""eq""ne"
price_conditions[].​valuestring^\d+(\.\d{1,4})?$必需

用于决定应用促销活动的价格范围的值。

promotion_periodsArray of objects(promotion_periods)

促销活动有效期。若指定了多个时间段,则date_fromdate_until均为必需。

promotion_periods[].​date_fromstring(date-time)必需

指定促销活动的开始日期。

示例: "2020-08-11T10:00:00+03:00"
promotion_periods[].​date_untilstring or null(date-time)

促销活动的结束日期。设置为null时,促销活动永久有效。仅在指定单个有效期时可设置为null

示例: "2020-08-11T20:00:00+03:00"
curl -i -X PUT \
  -u <username>:<password> \
  https://store.xsolla.com/api/v3/project/44056/admin/promotion/111425/bonus \
  -H 'Content-Type: application/json' \
  -d '{
    "attribute_conditions": [
      {
        "attribute": "account_status",
        "can_be_missing": false,
        "operator": "eq",
        "type": "string",
        "value": "golden"
      }
    ],
    "bonus": [
      {
        "quantity": 50000,
        "sku": "com.xsolla.mp_credits"
      }
    ],
    "condition": [
      {
        "sku": "com.xsolla.year_1_season_pass"
      }
    ],
    "name": {
      "de-DE": "Neujahrsbonus",
      "en-US": "New Year Bonus"
    },
    "promotion_periods": [
      {
        "date_from": "2020-04-15T18:16:00+05:00",
        "date_until": "2020-04-25T18:16:00+05:00"
      }
    ]
  }'

响应

促销活动已成功更新。

响应
无内容

个性化目录

Personalization allows you to specify the conditions for displaying the item catalog and applying promotions only for specific authorized users. Conditions are defined based on user attributes and allow you to offer items and promotions that are most relevant to particular users.

The following personalization types are available:

  • Xsolla-side personalization. Personalization rules and logic are configured and stored on the Xsolla side. You pass user attributes, and Xsolla uses them to generate a personalized catalog.
  • Partner-side personalization. You configure personalization rules and logic on your side and send a final catalog payload for a specific user to Xsolla.
Note

You can use only one personalization type. To change it, follow the instructions.

To configure personalization on the Xsolla side using the Xsolla API:

  1. Create items using the API calls from the Admin subsection of the Virtual items and currency, Bundles or Game keys groups.

  2. Set up user attributes using the Xsolla Login API and keep them synchronized by updating data in Xsolla whenever changes occur in your game.

  3. Configure personalization for items or promotions:

  4. Pass the user JWT with user attributes to the catalog retrieval API calls to receive a personalized catalog.

Sequence for configuring and applying Xsolla-side personalization for item catalog:

Personalization for item catalog

Sequence for configuring and applying Xsolla-side personalization for promotions:

Personalization for promotions

操作
操作
操作
操作
操作
操作
操作
操作
操作
操作
操作